use 5.010000;
use ExtUtils::MakeMaker;

WriteMakefile(
    NAME              => 'SOAP::WSDL',
    VERSION_FROM      => 'lib/SOAP/WSDL.pm',
    PREREQ_PM         => {
        'Class::Std::Fast'        => q(0.000005),
        'Cwd'                     => 0,
        'Data::Dumper'            => 0,
        'Date::Format'            => 0,
        'Date::Parse'             => 0,
        'File::Basename'          => 0,
        'File::Path'              => 0,
        'File::Spec'              => 0,
        'Getopt::Long'            => 0,
        'LWP::UserAgent'          => 0,
        'List::Util'              => 0,
        'Module::Build'           => 0,
        'Storable'                => 0,
        'Template'                => q(2.18),
        'Term::ReadKey'           => 0,
        'Test::More'              => 0,
        'URI'                     => 0,
        'XML::Parser::Expat'      => 0,
        'Class::Load'             => 0.20,
        'Class::Load'             => 0,
        'perl'                    => q(5.008),
    },
    TEST_REQUIRES => {
        'Attribute::Handlers' => 0,
        'CGI' => 0,
        'Cwd' => 0,
        'English' => 0,
        'File::Find' => 0,
        'File::Path' => 0,
        'File::Spec' => 0,
        'IO::File' => 0,
        'IO::Scalar' => 0,
        'IO::Handle' => 0,
        'IPC::Open3' => 0,
        'Moose' => 0,
        'Storable' => 0,
        'Test::CPAN::Meta' => 0,
        'Test::Class' => 0,
        'Test::MockObject' => 0,
        'Test::More' => 0,
        'Test::Pod::Content' => 0,
        'Test::Warn' => 0,
        'Test::XML' => 0,
        'XML::LibXML' => 0,
        'diagnostics' => 0,
        'lib' => 0,
        'parent' => 0,
        'utf8' => 0,
    },
    test => { RECURSIVE_TEST_FILES => 1, },
    ABSTRACT_FROM  => 'lib/SOAP/WSDL.pm',
    AUTHOR       => 'Scott Walters <scott@slowass.net>',
    EXE_FILES    => [ 'bin/wsdl2perl.pl' ],
    (eval { ExtUtils::MakeMaker->VERSION(6.46) } ? (META_MERGE => {
    'meta-spec' => { version => 2 },
     resources => {
         repository => {
             type => 'git',
             url  => 'https://github.com/scrottie/SOAP-WSDL.git',
             web  => 'https://github.com/scrottie/SOAP-WSDL',
         },
     }})
     : ()
   ),
);

